apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "my-app2-chart.name" . }}
  annotations:
    {{- toYaml . | nindent 4 }}
  labels:
    svc: {{ include "my-app2-chart.name" . }}
    {{ include "common.podientityLabels" . }}
spec:
  {{- if not .Values.autoscaling.enabled }}
  replicas: {{ .Values.replicaCount }}
  {{- end }}
  selector:
    matchLabels:
      svc: {{ include "my-app2-chart.name" . }}
      {{ include "common.podientityLabels" . }}
  revisionHistoryLimit: {{ .Values.revisionHistoryLimit }}
  template:
    metadata:
      {{- with .Values.podAnnotations }}
      annotations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      labels:
        svc: {{ include "my-app2-chart.name" . }}
        {{ include "common.podientityLabels" . }}
    spec:
#      affinity:
#        podAntiAffinity:
#          requiredDuringSchedulingIgnoredDuringExecution:
#          - labelSelector:
#              matchExpressions:
#              - key: svc
#                operator: In
#                values:
#                - {{ include "my-app2-chart.name" . }}
#            topologyKey: kubernetes.io/hostname
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "my-app2-chart.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ include "my-app2-chart.name" . }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          ports:
            {{- range $key, $value := .Values.service.svc }}
            - containerPort: {{ $value }}
              name: {{ $key }}
            {{- end }}
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
          env:
            - name: SERVICE
              value: {{ include "my-app2-chart.name" . }}
            {{- range $key, $value := .Values.env }}
            - name: {{ $key }}
              value: {{ $value | quote }}
            {{- end }}
            {{- range $key, $value := .Values.envSecret }}
            - name: {{ $key }}
              valueFrom:
                secretKeyRef:
                  name: {{ $value | quote }}
                  key: {{ $key }}
            {{- end }}
          {{- if and .Values.lifecyclepoststart.enabled .Values.lifecyclepoststart.command }}
          lifecycle:
            postStart:
              exec:
                command: 
                  {{- range .Values.lifecyclepoststart.command }}
                  - {{ . }}
                  {{- end }}    
          {{- end }}
      #     volumeMounts:
      #       - mountPath: /var/www/private-files
      #         name: privatefiles-vol
              
      #       - mountPath: /var/www/web/sites/default/files
      #         name: publicfiles-vol
            
      #       - name: secrets-store01-inline
      #         mountPath: "/mnt/secrets-store"
      #         readOnly: true
                        
      #       - mountPath: /var/www/web/sites/default/settings.preprod.php
      #         name: drupal-settings-file
      #         subPath: settings.preprod.php
            
      #       - mountPath: /var/www/web/sites/default/services.yml
      #         name: drupal-services-file
      #         subPath: services.yml  
  
      # volumes:
      #   - name: publicfiles-vol
      #     persistentVolumeClaim:
      #       claimName: tccchms-publicfiles-pvc
            
      #   - name: privatefiles-vol
      #     persistentVolumeClaim:
      #       claimName: tccchms-privatefiles-pvc
        
      #   - name: drupal-settings-file
      #     secret:
      #       secretName: {{ include "my-app2-chart.name" . }}-{{ .Values.commonInfo.env }}-settings
            
      #   - name: drupal-services-file
      #     secret: 
      #       secretName: {{ include "my-app2-chart.name" . }}-{{ .Values.commonInfo.env }}-services
          
      #   - name: secrets-store01-inline
      #     csi:
      #       driver: secrets-store.csi.k8s.io
      #       readOnly: true
      #       volumeAttributes:
      #         secretProviderClass: "tccchms-pre-scp"
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
